<template>
  <div>
    <el-form ref="queryForm" :model="searchForm" label-width="0" inline>
      <el-form-item>
        <el-input
          v-model="searchForm.extraPayName"
          placeholder="请输入名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery">搜索</el-button>
        <el-button @click="resetQuery">重置</el-button>
        <el-button type="primary" @click="openForm('create', null)">新增</el-button>
      </el-form-item>
    </el-form>
    <el-table v-loading="loading" :data="tableList">
      <el-table-column prop="extraPayName" label="支出项" />
      <el-table-column prop="isPercentage" label="是否扣除提成">
        <template #default="{ row }">
          {{ row.isPercentage ? '是' : '否' }}
        </template>
      </el-table-column>
      <el-table-column prop="sort" label="排序" width="100px" />
      <el-table-column prop="remark" label="备注" />
      <el-table-column
        label="创建时间"
        prop="createTime"
        width="180px"
        :formatter="dateFormatter"
      />
      <el-table-column label="操作">
        <template #default="scope">
          <el-button type="primary" text @click="openForm('update', scope.row.id)">
            修改
          </el-button>
          <el-button type="danger" text @click="handleDelete(scope.row.id)"> 删除 </el-button>
        </template>
      </el-table-column>
    </el-table>
    <Pagination
      v-model:limit="searchForm.pageSize"
      v-model:page="searchForm.pageNo"
      :total="total"
      @pagination="getList"
    />

    <DialogExtraFee ref="intentionDialog" @success="handleQuery" />
  </div>
</template>

<script setup name="ExtraFeeType">
import { dateFormatter } from '@/utils/formatTime'
import DialogExtraFee from './DialogExtraFee.vue'
import * as ExtraFeeApi from '@/api/clue/extraFee'
import { removeNullField } from '@/utils'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const searchForm = ref({
  extraPayName: '',
  pageSize: 20,
  pageNo: 1
})

const total = ref(0)
const intentionDialog = ref()
const tableList = ref([])
const loading = ref(false)

function handleQuery() {
  searchForm.value.pageNo = 1
  getList()
}
function resetQuery() {
  searchForm.value = {
    extraPayName: '',
    pageSize: 20,
    pageNo: 1
  }
  getList()
}

async function getList() {
  loading.value = true
  try {
    const data = await ExtraFeeApi.getExtraFeePage(removeNullField(searchForm.value))
    tableList.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

function openForm(type, id) {
  intentionDialog.value.open(type, id)
}

async function handleDelete(id) {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await ExtraFeeApi.deleteExtraFee(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

onMounted(() => {
  handleQuery()
})
</script>

<style lang="scss" scoped></style>
